# coding: utf-8

"""
    Python SDK for Opsgenie REST API

    Python SDK for Opsgenie REST API  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@opsgenie.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401
import six

from opsgenie_sdk.api_client import ApiClient
from opsgenie_sdk.exceptions import (
    ApiTypeError,
    ApiValueError
)


# python 2 and python 3 compatibility library


class AlertApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def acknowledge_alert(self, identifier, **kwargs):  # noqa: E501
        """Acknowledge Alert  # noqa: E501

        Acknowledges alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.acknowledge_alert(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param AcknowledgeAlertPayload acknowledge_alert_payload: Request payload of acknowledging alert action
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.acknowledge_alert_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.acknowledge_alert_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def acknowledge_alert_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """Acknowledge Alert  # noqa: E501

        Acknowledges alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.acknowledge_alert_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param AcknowledgeAlertPayload acknowledge_alert_payload: Request payload of acknowledging alert action
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type', 'acknowledge_alert_payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method acknowledge_alert" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `acknowledge_alert`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'acknowledge_alert_payload' in local_var_params:
            body_params = local_var_params['acknowledge_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/acknowledge', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_attachment(self, identifier, file, **kwargs):  # noqa: E501
        """Add Alert Attachment  # noqa: E501

        Add Alert Attachment to related alert  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_attachment(identifier, file, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param file file: Attachment file to be uploaded (required)
        :param str alert_identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :param str index_file: Name of html file which will be shown when attachment clicked on UI
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_attachment_with_http_info(identifier, file, **kwargs)  # noqa: E501
        else:
            (data) = self.add_attachment_with_http_info(identifier, file, **kwargs)  # noqa: E501
            return data

    def add_attachment_with_http_info(self, identifier, file, **kwargs):  # noqa: E501
        """Add Alert Attachment  # noqa: E501

        Add Alert Attachment to related alert  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_attachment_with_http_info(identifier, file, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param file file: Attachment file to be uploaded (required)
        :param str alert_identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :param str index_file: Name of html file which will be shown when attachment clicked on UI
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'file', 'alert_identifier_type', 'user', 'index_file']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_attachment" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `add_attachment`")  # noqa: E501
        # verify the required parameter 'file' is set
        if ('file' not in local_var_params or
                local_var_params['file'] is None):
            raise ApiValueError("Missing the required parameter `file` when calling `add_attachment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'alert_identifier_type' in local_var_params:
            query_params.append(('alertIdentifierType', local_var_params['alert_identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'file' in local_var_params:
            local_var_files['file'] = local_var_params['file']  # noqa: E501
        if 'user' in local_var_params:
            form_params.append(('user', local_var_params['user']))  # noqa: E501
        if 'index_file' in local_var_params:
            form_params.append(('indexFile', local_var_params['index_file']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['multipart/form-data'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/attachments', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_details(self, identifier, add_details_to_alert_payload, **kwargs):  # noqa: E501
        """Add Details  # noqa: E501

        Add details to the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_details(identifier, add_details_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddDetailsToAlertPayload add_details_to_alert_payload: Request payload of adding alert details action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_details_with_http_info(identifier, add_details_to_alert_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.add_details_with_http_info(identifier, add_details_to_alert_payload, **kwargs)  # noqa: E501
            return data

    def add_details_with_http_info(self, identifier, add_details_to_alert_payload, **kwargs):  # noqa: E501
        """Add Details  # noqa: E501

        Add details to the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_details_with_http_info(identifier, add_details_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddDetailsToAlertPayload add_details_to_alert_payload: Request payload of adding alert details action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'add_details_to_alert_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_details" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `add_details`")  # noqa: E501
        # verify the required parameter 'add_details_to_alert_payload' is set
        if ('add_details_to_alert_payload' not in local_var_params or
                local_var_params['add_details_to_alert_payload'] is None):
            raise ApiValueError("Missing the required parameter `add_details_to_alert_payload` when calling `add_details`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'add_details_to_alert_payload' in local_var_params:
            body_params = local_var_params['add_details_to_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/details', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_note(self, identifier, add_note_to_alert_payload, **kwargs):  # noqa: E501
        """Add Note  # noqa: E501

        Adds note to alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_note(identifier, add_note_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddNoteToAlertPayload add_note_to_alert_payload: Request payload of adding note to alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_note_with_http_info(identifier, add_note_to_alert_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.add_note_with_http_info(identifier, add_note_to_alert_payload, **kwargs)  # noqa: E501
            return data

    def add_note_with_http_info(self, identifier, add_note_to_alert_payload, **kwargs):  # noqa: E501
        """Add Note  # noqa: E501

        Adds note to alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_note_with_http_info(identifier, add_note_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddNoteToAlertPayload add_note_to_alert_payload: Request payload of adding note to alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'add_note_to_alert_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_note" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `add_note`")  # noqa: E501
        # verify the required parameter 'add_note_to_alert_payload' is set
        if ('add_note_to_alert_payload' not in local_var_params or
                local_var_params['add_note_to_alert_payload'] is None):
            raise ApiValueError("Missing the required parameter `add_note_to_alert_payload` when calling `add_note`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'add_note_to_alert_payload' in local_var_params:
            body_params = local_var_params['add_note_to_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/notes', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_responder(self, identifier, add_responder_to_alert_payload, **kwargs):  # noqa: E501
        """Add Responder  # noqa: E501

        Add responder to alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_responder(identifier, add_responder_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddResponderToAlertPayload add_responder_to_alert_payload: Request payload of adding responder to alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_responder_with_http_info(identifier, add_responder_to_alert_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.add_responder_with_http_info(identifier, add_responder_to_alert_payload, **kwargs)  # noqa: E501
            return data

    def add_responder_with_http_info(self, identifier, add_responder_to_alert_payload, **kwargs):  # noqa: E501
        """Add Responder  # noqa: E501

        Add responder to alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_responder_with_http_info(identifier, add_responder_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddResponderToAlertPayload add_responder_to_alert_payload: Request payload of adding responder to alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'add_responder_to_alert_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_responder" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `add_responder`")  # noqa: E501
        # verify the required parameter 'add_responder_to_alert_payload' is set
        if ('add_responder_to_alert_payload' not in local_var_params or
                local_var_params['add_responder_to_alert_payload'] is None):
            raise ApiValueError("Missing the required parameter `add_responder_to_alert_payload` when calling `add_responder`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'add_responder_to_alert_payload' in local_var_params:
            body_params = local_var_params['add_responder_to_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/responders', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_tags(self, identifier, add_tags_to_alert_payload, **kwargs):  # noqa: E501
        """Add Tags  # noqa: E501

        Add tags to the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_tags(identifier, add_tags_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddTagsToAlertPayload add_tags_to_alert_payload: Request payload of creating alert tags action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_tags_with_http_info(identifier, add_tags_to_alert_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.add_tags_with_http_info(identifier, add_tags_to_alert_payload, **kwargs)  # noqa: E501
            return data

    def add_tags_with_http_info(self, identifier, add_tags_to_alert_payload, **kwargs):  # noqa: E501
        """Add Tags  # noqa: E501

        Add tags to the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_tags_with_http_info(identifier, add_tags_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddTagsToAlertPayload add_tags_to_alert_payload: Request payload of creating alert tags action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'add_tags_to_alert_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_tags" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `add_tags`")  # noqa: E501
        # verify the required parameter 'add_tags_to_alert_payload' is set
        if ('add_tags_to_alert_payload' not in local_var_params or
                local_var_params['add_tags_to_alert_payload'] is None):
            raise ApiValueError("Missing the required parameter `add_tags_to_alert_payload` when calling `add_tags`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'add_tags_to_alert_payload' in local_var_params:
            body_params = local_var_params['add_tags_to_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/tags', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_team(self, identifier, add_team_to_alert_payload, **kwargs):  # noqa: E501
        """Add Team  # noqa: E501

        Add team to alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_team(identifier, add_team_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddTeamToAlertPayload add_team_to_alert_payload: Request payload of adding team to alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_team_with_http_info(identifier, add_team_to_alert_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.add_team_with_http_info(identifier, add_team_to_alert_payload, **kwargs)  # noqa: E501
            return data

    def add_team_with_http_info(self, identifier, add_team_to_alert_payload, **kwargs):  # noqa: E501
        """Add Team  # noqa: E501

        Add team to alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_team_with_http_info(identifier, add_team_to_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AddTeamToAlertPayload add_team_to_alert_payload: Request payload of adding team to alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'add_team_to_alert_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_team" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `add_team`")  # noqa: E501
        # verify the required parameter 'add_team_to_alert_payload' is set
        if ('add_team_to_alert_payload' not in local_var_params or
                local_var_params['add_team_to_alert_payload'] is None):
            raise ApiValueError("Missing the required parameter `add_team_to_alert_payload` when calling `add_team`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'add_team_to_alert_payload' in local_var_params:
            body_params = local_var_params['add_team_to_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/teams', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def assign_alert(self, identifier, assign_alert_payload, **kwargs):  # noqa: E501
        """Assign Alert  # noqa: E501

        Assign alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.assign_alert(identifier, assign_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AssignAlertPayload assign_alert_payload: Request payload of assigning alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.assign_alert_with_http_info(identifier, assign_alert_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.assign_alert_with_http_info(identifier, assign_alert_payload, **kwargs)  # noqa: E501
            return data

    def assign_alert_with_http_info(self, identifier, assign_alert_payload, **kwargs):  # noqa: E501
        """Assign Alert  # noqa: E501

        Assign alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.assign_alert_with_http_info(identifier, assign_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param AssignAlertPayload assign_alert_payload: Request payload of assigning alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'assign_alert_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method assign_alert" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `assign_alert`")  # noqa: E501
        # verify the required parameter 'assign_alert_payload' is set
        if ('assign_alert_payload' not in local_var_params or
                local_var_params['assign_alert_payload'] is None):
            raise ApiValueError("Missing the required parameter `assign_alert_payload` when calling `assign_alert`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'assign_alert_payload' in local_var_params:
            body_params = local_var_params['assign_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/assign', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def close_alert(self, identifier, **kwargs):  # noqa: E501
        """Close Alert  # noqa: E501

        Closes alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.close_alert(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param CloseAlertPayload close_alert_payload: Request payload of closing alert action
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.close_alert_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.close_alert_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def close_alert_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """Close Alert  # noqa: E501

        Closes alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.close_alert_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param CloseAlertPayload close_alert_payload: Request payload of closing alert action
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type', 'close_alert_payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method close_alert" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `close_alert`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'close_alert_payload' in local_var_params:
            body_params = local_var_params['close_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/close', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def count_alerts(self, **kwargs):  # noqa: E501
        """Count Alerts  # noqa: E501

        Count alerts in Opsgenie  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.count_alerts(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str query: Search query to apply while filtering the alerts
        :param str search_identifier: Identifier of the saved search query to apply while filtering the alerts
        :param str search_identifier_type: Identifier type of the saved search query. Possible values are id and name. Default value is id. If searchIdentifier is not provided, this value is ignored.
        :return: GetCountAlertsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.count_alerts_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.count_alerts_with_http_info(**kwargs)  # noqa: E501
            return data

    def count_alerts_with_http_info(self, **kwargs):  # noqa: E501
        """Count Alerts  # noqa: E501

        Count alerts in Opsgenie  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.count_alerts_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str query: Search query to apply while filtering the alerts
        :param str search_identifier: Identifier of the saved search query to apply while filtering the alerts
        :param str search_identifier_type: Identifier type of the saved search query. Possible values are id and name. Default value is id. If searchIdentifier is not provided, this value is ignored.
        :return: GetCountAlertsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['query', 'search_identifier', 'search_identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method count_alerts" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'query' in local_var_params:
            query_params.append(('query', local_var_params['query']))  # noqa: E501
        if 'search_identifier' in local_var_params:
            query_params.append(('searchIdentifier', local_var_params['search_identifier']))  # noqa: E501
        if 'search_identifier_type' in local_var_params:
            query_params.append(('searchIdentifierType', local_var_params['search_identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/count', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetCountAlertsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_alert(self, create_alert_payload, **kwargs):  # noqa: E501
        """Create Alert  # noqa: E501

        Creates a new alert  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_alert(create_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateAlertPayload create_alert_payload: Request payload of created alert (required)
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_alert_with_http_info(create_alert_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.create_alert_with_http_info(create_alert_payload, **kwargs)  # noqa: E501
            return data

    def create_alert_with_http_info(self, create_alert_payload, **kwargs):  # noqa: E501
        """Create Alert  # noqa: E501

        Creates a new alert  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_alert_with_http_info(create_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateAlertPayload create_alert_payload: Request payload of created alert (required)
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['create_alert_payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_alert" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'create_alert_payload' is set
        if ('create_alert_payload' not in local_var_params or
                local_var_params['create_alert_payload'] is None):
            raise ApiValueError("Missing the required parameter `create_alert_payload` when calling `create_alert`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'create_alert_payload' in local_var_params:
            body_params = local_var_params['create_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_saved_searches(self, create_saved_search_payload, **kwargs):  # noqa: E501
        """Create Saved Search  # noqa: E501

        Create saved search with given fields  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_saved_searches(create_saved_search_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateSavedSearchPayload create_saved_search_payload: Request payload of creating saved search (required)
        :return: CreateSavedSearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_saved_searches_with_http_info(create_saved_search_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.create_saved_searches_with_http_info(create_saved_search_payload, **kwargs)  # noqa: E501
            return data

    def create_saved_searches_with_http_info(self, create_saved_search_payload, **kwargs):  # noqa: E501
        """Create Saved Search  # noqa: E501

        Create saved search with given fields  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_saved_searches_with_http_info(create_saved_search_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateSavedSearchPayload create_saved_search_payload: Request payload of creating saved search (required)
        :return: CreateSavedSearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['create_saved_search_payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_saved_searches" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'create_saved_search_payload' is set
        if ('create_saved_search_payload' not in local_var_params or
                local_var_params['create_saved_search_payload'] is None):
            raise ApiValueError("Missing the required parameter `create_saved_search_payload` when calling `create_saved_searches`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'create_saved_search_payload' in local_var_params:
            body_params = local_var_params['create_saved_search_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/saved-searches', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CreateSavedSearchResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_alert(self, identifier, **kwargs):  # noqa: E501
        """Delete Alert  # noqa: E501

        Deletes an alert using alert id, tiny id or alias  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_alert(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :param str source: Display name of the request source
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_alert_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_alert_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def delete_alert_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """Delete Alert  # noqa: E501

        Deletes an alert using alert id, tiny id or alias  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_alert_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :param str source: Display name of the request source
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type', 'user', 'source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_alert" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `delete_alert`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501
        if 'user' in local_var_params:
            query_params.append(('user', local_var_params['user']))  # noqa: E501
        if 'source' in local_var_params:
            query_params.append(('source', local_var_params['source']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_saved_search(self, identifier, **kwargs):  # noqa: E501
        """Delete Saved Search  # noqa: E501

        Deletes saved search using given search identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_saved_search(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of the saved search which could be 'id' or 'name' (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', or 'name'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_saved_search_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_saved_search_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def delete_saved_search_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """Delete Saved Search  # noqa: E501

        Deletes saved search using given search identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_saved_search_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of the saved search which could be 'id' or 'name' (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', or 'name'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_saved_search" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `delete_saved_search`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/saved-searches/{identifier}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def escalate_alert(self, identifier, escalate_alert_to_next_payload, **kwargs):  # noqa: E501
        """Escalate Alert  # noqa: E501

        Escalate alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.escalate_alert(identifier, escalate_alert_to_next_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param EscalateAlertToNextPayload escalate_alert_to_next_payload: Request payload of escalating alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.escalate_alert_with_http_info(identifier, escalate_alert_to_next_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.escalate_alert_with_http_info(identifier, escalate_alert_to_next_payload, **kwargs)  # noqa: E501
            return data

    def escalate_alert_with_http_info(self, identifier, escalate_alert_to_next_payload, **kwargs):  # noqa: E501
        """Escalate Alert  # noqa: E501

        Escalate alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.escalate_alert_with_http_info(identifier, escalate_alert_to_next_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param EscalateAlertToNextPayload escalate_alert_to_next_payload: Request payload of escalating alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'escalate_alert_to_next_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method escalate_alert" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `escalate_alert`")  # noqa: E501
        # verify the required parameter 'escalate_alert_to_next_payload' is set
        if ('escalate_alert_to_next_payload' not in local_var_params or
                local_var_params['escalate_alert_to_next_payload'] is None):
            raise ApiValueError("Missing the required parameter `escalate_alert_to_next_payload` when calling `escalate_alert`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'escalate_alert_to_next_payload' in local_var_params:
            body_params = local_var_params['escalate_alert_to_next_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/escalate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def execute_custom_alert_action(self, identifier, action_name, **kwargs):  # noqa: E501
        """Custom Alert Action  # noqa: E501

        Custom actions for the alert  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.execute_custom_alert_action(identifier, action_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str action_name: Name of the action to execute (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param ExecuteCustomAlertActionPayload execute_custom_alert_action_payload: Request payload of executing custom alert action
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.execute_custom_alert_action_with_http_info(identifier, action_name, **kwargs)  # noqa: E501
        else:
            (data) = self.execute_custom_alert_action_with_http_info(identifier, action_name, **kwargs)  # noqa: E501
            return data

    def execute_custom_alert_action_with_http_info(self, identifier, action_name, **kwargs):  # noqa: E501
        """Custom Alert Action  # noqa: E501

        Custom actions for the alert  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.execute_custom_alert_action_with_http_info(identifier, action_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str action_name: Name of the action to execute (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param ExecuteCustomAlertActionPayload execute_custom_alert_action_payload: Request payload of executing custom alert action
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'action_name', 'identifier_type', 'execute_custom_alert_action_payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method execute_custom_alert_action" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `execute_custom_alert_action`")  # noqa: E501
        # verify the required parameter 'action_name' is set
        if ('action_name' not in local_var_params or
                local_var_params['action_name'] is None):
            raise ApiValueError("Missing the required parameter `action_name` when calling `execute_custom_alert_action`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501
        if 'action_name' in local_var_params:
            path_params['actionName'] = local_var_params['action_name']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'execute_custom_alert_action_payload' in local_var_params:
            body_params = local_var_params['execute_custom_alert_action_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/actions/{actionName}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_alert(self, identifier, **kwargs):  # noqa: E501
        """Get Alert  # noqa: E501

        Returns alert with given id, tiny id or alias  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_alert(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: GetAlertResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_alert_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.get_alert_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def get_alert_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """Get Alert  # noqa: E501

        Returns alert with given id, tiny id or alias  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_alert_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: GetAlertResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_alert" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `get_alert`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetAlertResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_attachment(self, identifier, attachment_id, **kwargs):  # noqa: E501
        """Get Alert Attachment  # noqa: E501

        Get alert attachment name and url for the given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_attachment(identifier, attachment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param int attachment_id: Identifier of alert attachment (required)
        :param str alert_identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: GetAlertAttachmentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_attachment_with_http_info(identifier, attachment_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_attachment_with_http_info(identifier, attachment_id, **kwargs)  # noqa: E501
            return data

    def get_attachment_with_http_info(self, identifier, attachment_id, **kwargs):  # noqa: E501
        """Get Alert Attachment  # noqa: E501

        Get alert attachment name and url for the given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_attachment_with_http_info(identifier, attachment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param int attachment_id: Identifier of alert attachment (required)
        :param str alert_identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: GetAlertAttachmentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'attachment_id', 'alert_identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_attachment" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `get_attachment`")  # noqa: E501
        # verify the required parameter 'attachment_id' is set
        if ('attachment_id' not in local_var_params or
                local_var_params['attachment_id'] is None):
            raise ApiValueError("Missing the required parameter `attachment_id` when calling `get_attachment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501
        if 'attachment_id' in local_var_params:
            path_params['attachmentId'] = local_var_params['attachment_id']  # noqa: E501

        query_params = []
        if 'alert_identifier_type' in local_var_params:
            query_params.append(('alertIdentifierType', local_var_params['alert_identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/attachments/{attachmentId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetAlertAttachmentResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_request_status(self, request_id, **kwargs):  # noqa: E501
        """Get Request Status of Alert  # noqa: E501

        Used to track the status and alert details (if any) of the request whose identifier is given  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_request_status(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: Universally unique identifier of the questioned request (required)
        :return: GetRequestStatusResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_request_status_with_http_info(request_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_request_status_with_http_info(request_id, **kwargs)  # noqa: E501
            return data

    def get_request_status_with_http_info(self, request_id, **kwargs):  # noqa: E501
        """Get Request Status of Alert  # noqa: E501

        Used to track the status and alert details (if any) of the request whose identifier is given  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_request_status_with_http_info(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: Universally unique identifier of the questioned request (required)
        :return: GetRequestStatusResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['request_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_request_status" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'request_id' is set
        if ('request_id' not in local_var_params or
                local_var_params['request_id'] is None):
            raise ApiValueError("Missing the required parameter `request_id` when calling `get_request_status`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'request_id' in local_var_params:
            path_params['requestId'] = local_var_params['request_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/requests/{requestId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetRequestStatusResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_saved_search(self, identifier, **kwargs):  # noqa: E501
        """Get Saved Search  # noqa: E501

        Get saved search for the given search identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_saved_search(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of the saved search which could be 'id' or 'name' (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', or 'name'
        :return: GetSavedSearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_saved_search_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.get_saved_search_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def get_saved_search_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """Get Saved Search  # noqa: E501

        Get saved search for the given search identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_saved_search_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of the saved search which could be 'id' or 'name' (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', or 'name'
        :return: GetSavedSearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_saved_search" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `get_saved_search`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/saved-searches/{identifier}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetSavedSearchResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_alerts(self, **kwargs):  # noqa: E501
        """List Alerts  # noqa: E501

        Returns list of alerts  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_alerts(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str query: Search query to apply while filtering the alerts
        :param str search_identifier: Identifier of the saved search query to apply while filtering the alerts
        :param str search_identifier_type: Identifier type of the saved search query. Possible values are 'id', or 'name'
        :param int offset: Start index of the result set (to apply pagination). Minimum value (and also default value) is 0
        :param int limit: Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 100
        :param str sort: Name of the field that result set will be sorted by
        :param str order: Sorting order of the result set
        :return: ListAlertsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_alerts_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.list_alerts_with_http_info(**kwargs)  # noqa: E501
            return data

    def list_alerts_with_http_info(self, **kwargs):  # noqa: E501
        """List Alerts  # noqa: E501

        Returns list of alerts  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_alerts_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str query: Search query to apply while filtering the alerts
        :param str search_identifier: Identifier of the saved search query to apply while filtering the alerts
        :param str search_identifier_type: Identifier type of the saved search query. Possible values are 'id', or 'name'
        :param int offset: Start index of the result set (to apply pagination). Minimum value (and also default value) is 0
        :param int limit: Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 100
        :param str sort: Name of the field that result set will be sorted by
        :param str order: Sorting order of the result set
        :return: ListAlertsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['query', 'search_identifier', 'search_identifier_type', 'offset', 'limit', 'sort', 'order']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_alerts" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        if 'offset' in local_var_params and local_var_params['offset'] < 0:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `offset` when calling `list_alerts`, must be a value greater than or equal to `0`")  # noqa: E501
        if 'limit' in local_var_params and local_var_params['limit'] > 100:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `limit` when calling `list_alerts`, must be a value less than or equal to `100`")  # noqa: E501
        if 'limit' in local_var_params and local_var_params['limit'] < 1:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `limit` when calling `list_alerts`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}

        query_params = []
        if 'query' in local_var_params:
            query_params.append(('query', local_var_params['query']))  # noqa: E501
        if 'search_identifier' in local_var_params:
            query_params.append(('searchIdentifier', local_var_params['search_identifier']))  # noqa: E501
        if 'search_identifier_type' in local_var_params:
            query_params.append(('searchIdentifierType', local_var_params['search_identifier_type']))  # noqa: E501
        if 'offset' in local_var_params:
            query_params.append(('offset', local_var_params['offset']))  # noqa: E501
        if 'limit' in local_var_params:
            query_params.append(('limit', local_var_params['limit']))  # noqa: E501
        if 'sort' in local_var_params:
            query_params.append(('sort', local_var_params['sort']))  # noqa: E501
        if 'order' in local_var_params:
            query_params.append(('order', local_var_params['order']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ListAlertsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_attachments(self, identifier, **kwargs):  # noqa: E501
        """List Alert Attachments  # noqa: E501

        List alert attachment names and urls for related alert  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_attachments(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str alert_identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: ListAlertAttachmentsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_attachments_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.list_attachments_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def list_attachments_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """List Alert Attachments  # noqa: E501

        List alert attachment names and urls for related alert  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_attachments_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str alert_identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: ListAlertAttachmentsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'alert_identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_attachments" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `list_attachments`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'alert_identifier_type' in local_var_params:
            query_params.append(('alertIdentifierType', local_var_params['alert_identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/attachments', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ListAlertAttachmentsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_logs(self, identifier, **kwargs):  # noqa: E501
        """List Alert Logs  # noqa: E501

        List alert logs for the given alert identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_logs(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str offset: Starting value of the offset property
        :param str direction: Page direction to apply for the given offset with 'next' and 'prev'
        :param int limit: Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 100
        :param str order: Sorting order of the result set
        :return: ListAlertLogsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_logs_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.list_logs_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def list_logs_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """List Alert Logs  # noqa: E501

        List alert logs for the given alert identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_logs_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str offset: Starting value of the offset property
        :param str direction: Page direction to apply for the given offset with 'next' and 'prev'
        :param int limit: Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 100
        :param str order: Sorting order of the result set
        :return: ListAlertLogsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type', 'offset', 'direction', 'limit', 'order']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_logs" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `list_logs`")  # noqa: E501

        if 'limit' in local_var_params and local_var_params['limit'] > 100:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `limit` when calling `list_logs`, must be a value less than or equal to `100`")  # noqa: E501
        if 'limit' in local_var_params and local_var_params['limit'] < 1:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `limit` when calling `list_logs`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501
        if 'offset' in local_var_params:
            query_params.append(('offset', local_var_params['offset']))  # noqa: E501
        if 'direction' in local_var_params:
            query_params.append(('direction', local_var_params['direction']))  # noqa: E501
        if 'limit' in local_var_params:
            query_params.append(('limit', local_var_params['limit']))  # noqa: E501
        if 'order' in local_var_params:
            query_params.append(('order', local_var_params['order']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/logs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ListAlertLogsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_notes(self, identifier, **kwargs):  # noqa: E501
        """List Alert Notes  # noqa: E501

        List alert notes for the given alert identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_notes(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str offset: Starting value of the offset property
        :param str direction: Page direction to apply for the given offset with 'next' and 'prev'
        :param int limit: Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 100
        :param str order: Sorting order of the result set
        :return: ListAlertNotesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_notes_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.list_notes_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def list_notes_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """List Alert Notes  # noqa: E501

        List alert notes for the given alert identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_notes_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str offset: Starting value of the offset property
        :param str direction: Page direction to apply for the given offset with 'next' and 'prev'
        :param int limit: Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 100
        :param str order: Sorting order of the result set
        :return: ListAlertNotesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type', 'offset', 'direction', 'limit', 'order']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_notes" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `list_notes`")  # noqa: E501

        if 'limit' in local_var_params and local_var_params['limit'] > 100:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `limit` when calling `list_notes`, must be a value less than or equal to `100`")  # noqa: E501
        if 'limit' in local_var_params and local_var_params['limit'] < 1:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `limit` when calling `list_notes`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501
        if 'offset' in local_var_params:
            query_params.append(('offset', local_var_params['offset']))  # noqa: E501
        if 'direction' in local_var_params:
            query_params.append(('direction', local_var_params['direction']))  # noqa: E501
        if 'limit' in local_var_params:
            query_params.append(('limit', local_var_params['limit']))  # noqa: E501
        if 'order' in local_var_params:
            query_params.append(('order', local_var_params['order']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/notes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ListAlertNotesResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_recipients(self, identifier, **kwargs):  # noqa: E501
        """List Alert Recipients  # noqa: E501

        List alert recipients for the given alert identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_recipients(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: ListAlertRecipientsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_recipients_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.list_recipients_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def list_recipients_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """List Alert Recipients  # noqa: E501

        List alert recipients for the given alert identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_recipients_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: ListAlertRecipientsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_recipients" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `list_recipients`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/recipients', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ListAlertRecipientsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_saved_searches(self, **kwargs):  # noqa: E501
        """Lists Saved Searches  # noqa: E501

        List all saved searches  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_saved_searches(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ListSavedSearchesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_saved_searches_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.list_saved_searches_with_http_info(**kwargs)  # noqa: E501
            return data

    def list_saved_searches_with_http_info(self, **kwargs):  # noqa: E501
        """Lists Saved Searches  # noqa: E501

        List all saved searches  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_saved_searches_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: ListSavedSearchesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_saved_searches" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/saved-searches', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ListSavedSearchesResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def remove_attachment(self, identifier, attachment_id, **kwargs):  # noqa: E501
        """Remove Alert Attachment  # noqa: E501

        Remove alert attachment for the given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_attachment(identifier, attachment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param int attachment_id: Identifier of alert attachment (required)
        :param str alert_identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.remove_attachment_with_http_info(identifier, attachment_id, **kwargs)  # noqa: E501
        else:
            (data) = self.remove_attachment_with_http_info(identifier, attachment_id, **kwargs)  # noqa: E501
            return data

    def remove_attachment_with_http_info(self, identifier, attachment_id, **kwargs):  # noqa: E501
        """Remove Alert Attachment  # noqa: E501

        Remove alert attachment for the given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_attachment_with_http_info(identifier, attachment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param int attachment_id: Identifier of alert attachment (required)
        :param str alert_identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'attachment_id', 'alert_identifier_type', 'user']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_attachment" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `remove_attachment`")  # noqa: E501
        # verify the required parameter 'attachment_id' is set
        if ('attachment_id' not in local_var_params or
                local_var_params['attachment_id'] is None):
            raise ApiValueError("Missing the required parameter `attachment_id` when calling `remove_attachment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501
        if 'attachment_id' in local_var_params:
            path_params['attachmentId'] = local_var_params['attachment_id']  # noqa: E501

        query_params = []
        if 'alert_identifier_type' in local_var_params:
            query_params.append(('alertIdentifierType', local_var_params['alert_identifier_type']))  # noqa: E501
        if 'user' in local_var_params:
            query_params.append(('user', local_var_params['user']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/attachments/{attachmentId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def remove_details(self, identifier, keys, **kwargs):  # noqa: E501
        """Remove Details  # noqa: E501

        Remove details of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_details(identifier, keys, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param list[str] keys: Comma separated list of keys to remove from the custom properties of the alert (e.g. 'key1,key2') (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :param str note: Additional alert note to add
        :param str source: Display name of the request source
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.remove_details_with_http_info(identifier, keys, **kwargs)  # noqa: E501
        else:
            (data) = self.remove_details_with_http_info(identifier, keys, **kwargs)  # noqa: E501
            return data

    def remove_details_with_http_info(self, identifier, keys, **kwargs):  # noqa: E501
        """Remove Details  # noqa: E501

        Remove details of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_details_with_http_info(identifier, keys, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param list[str] keys: Comma separated list of keys to remove from the custom properties of the alert (e.g. 'key1,key2') (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :param str note: Additional alert note to add
        :param str source: Display name of the request source
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'keys', 'identifier_type', 'user', 'note', 'source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_details" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `remove_details`")  # noqa: E501
        # verify the required parameter 'keys' is set
        if ('keys' not in local_var_params or
                local_var_params['keys'] is None):
            raise ApiValueError("Missing the required parameter `keys` when calling `remove_details`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501
        if 'user' in local_var_params:
            query_params.append(('user', local_var_params['user']))  # noqa: E501
        if 'note' in local_var_params:
            query_params.append(('note', local_var_params['note']))  # noqa: E501
        if 'source' in local_var_params:
            query_params.append(('source', local_var_params['source']))  # noqa: E501
        if 'keys' in local_var_params:
            query_params.append(('keys', local_var_params['keys']))  # noqa: E501
            collection_formats['keys'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/details', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def remove_tags(self, identifier, tags, **kwargs):  # noqa: E501
        """Remove Tags  # noqa: E501

        Remove tags of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_tags(identifier, tags, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param list[str] tags: Tags field of the given alert as comma seperated values (e.g. 'tag1, tag2') (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :param str note: Additional alert note to add
        :param str source: Display name of the request source
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.remove_tags_with_http_info(identifier, tags, **kwargs)  # noqa: E501
        else:
            (data) = self.remove_tags_with_http_info(identifier, tags, **kwargs)  # noqa: E501
            return data

    def remove_tags_with_http_info(self, identifier, tags, **kwargs):  # noqa: E501
        """Remove Tags  # noqa: E501

        Remove tags of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_tags_with_http_info(identifier, tags, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param list[str] tags: Tags field of the given alert as comma seperated values (e.g. 'tag1, tag2') (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param str user: Display name of the request owner
        :param str note: Additional alert note to add
        :param str source: Display name of the request source
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'tags', 'identifier_type', 'user', 'note', 'source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_tags" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `remove_tags`")  # noqa: E501
        # verify the required parameter 'tags' is set
        if ('tags' not in local_var_params or
                local_var_params['tags'] is None):
            raise ApiValueError("Missing the required parameter `tags` when calling `remove_tags`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501
        if 'user' in local_var_params:
            query_params.append(('user', local_var_params['user']))  # noqa: E501
        if 'note' in local_var_params:
            query_params.append(('note', local_var_params['note']))  # noqa: E501
        if 'source' in local_var_params:
            query_params.append(('source', local_var_params['source']))  # noqa: E501
        if 'tags' in local_var_params:
            query_params.append(('tags', local_var_params['tags']))  # noqa: E501
            collection_formats['tags'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/tags', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def snooze_alert(self, identifier, snooze_alert_payload, **kwargs):  # noqa: E501
        """Snooze Alert  # noqa: E501

        Snooze alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.snooze_alert(identifier, snooze_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param SnoozeAlertPayload snooze_alert_payload: Request payload of snoozing alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.snooze_alert_with_http_info(identifier, snooze_alert_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.snooze_alert_with_http_info(identifier, snooze_alert_payload, **kwargs)  # noqa: E501
            return data

    def snooze_alert_with_http_info(self, identifier, snooze_alert_payload, **kwargs):  # noqa: E501
        """Snooze Alert  # noqa: E501

        Snooze alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.snooze_alert_with_http_info(identifier, snooze_alert_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param SnoozeAlertPayload snooze_alert_payload: Request payload of snoozing alert action (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'snooze_alert_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method snooze_alert" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `snooze_alert`")  # noqa: E501
        # verify the required parameter 'snooze_alert_payload' is set
        if ('snooze_alert_payload' not in local_var_params or
                local_var_params['snooze_alert_payload'] is None):
            raise ApiValueError("Missing the required parameter `snooze_alert_payload` when calling `snooze_alert`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'snooze_alert_payload' in local_var_params:
            body_params = local_var_params['snooze_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/snooze', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def un_acknowledge_alert(self, identifier, **kwargs):  # noqa: E501
        """UnAcknowledge Alert  # noqa: E501

        UnAcknowledge alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.un_acknowledge_alert(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param UnAcknowledgeAlertPayload un_acknowledge_alert_payload: Request payload of unacknowledging alert action
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.un_acknowledge_alert_with_http_info(identifier, **kwargs)  # noqa: E501
        else:
            (data) = self.un_acknowledge_alert_with_http_info(identifier, **kwargs)  # noqa: E501
            return data

    def un_acknowledge_alert_with_http_info(self, identifier, **kwargs):  # noqa: E501
        """UnAcknowledge Alert  # noqa: E501

        UnAcknowledge alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.un_acknowledge_alert_with_http_info(identifier, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :param UnAcknowledgeAlertPayload un_acknowledge_alert_payload: Request payload of unacknowledging alert action
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'identifier_type', 'un_acknowledge_alert_payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method un_acknowledge_alert" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `un_acknowledge_alert`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'un_acknowledge_alert_payload' in local_var_params:
            body_params = local_var_params['un_acknowledge_alert_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/unacknowledge', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_alert_description(self, identifier, update_alert_description_payload, **kwargs):  # noqa: E501
        """Update Alert Description  # noqa: E501

        Update the description of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_alert_description(identifier, update_alert_description_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param UpdateAlertDescriptionPayload update_alert_description_payload: Request payload of update alert description (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_alert_description_with_http_info(identifier, update_alert_description_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.update_alert_description_with_http_info(identifier, update_alert_description_payload, **kwargs)  # noqa: E501
            return data

    def update_alert_description_with_http_info(self, identifier, update_alert_description_payload, **kwargs):  # noqa: E501
        """Update Alert Description  # noqa: E501

        Update the description of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_alert_description_with_http_info(identifier, update_alert_description_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param UpdateAlertDescriptionPayload update_alert_description_payload: Request payload of update alert description (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'update_alert_description_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_alert_description" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `update_alert_description`")  # noqa: E501
        # verify the required parameter 'update_alert_description_payload' is set
        if ('update_alert_description_payload' not in local_var_params or
                local_var_params['update_alert_description_payload'] is None):
            raise ApiValueError("Missing the required parameter `update_alert_description_payload` when calling `update_alert_description`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'update_alert_description_payload' in local_var_params:
            body_params = local_var_params['update_alert_description_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/description', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_alert_message(self, identifier, update_alert_message_payload, **kwargs):  # noqa: E501
        """Update Alert Message  # noqa: E501

        Update the message of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_alert_message(identifier, update_alert_message_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param UpdateAlertMessagePayload update_alert_message_payload: Request payload of update alert message (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_alert_message_with_http_info(identifier, update_alert_message_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.update_alert_message_with_http_info(identifier, update_alert_message_payload, **kwargs)  # noqa: E501
            return data

    def update_alert_message_with_http_info(self, identifier, update_alert_message_payload, **kwargs):  # noqa: E501
        """Update Alert Message  # noqa: E501

        Update the message of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_alert_message_with_http_info(identifier, update_alert_message_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param UpdateAlertMessagePayload update_alert_message_payload: Request payload of update alert message (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'update_alert_message_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_alert_message" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `update_alert_message`")  # noqa: E501
        # verify the required parameter 'update_alert_message_payload' is set
        if ('update_alert_message_payload' not in local_var_params or
                local_var_params['update_alert_message_payload'] is None):
            raise ApiValueError("Missing the required parameter `update_alert_message_payload` when calling `update_alert_message`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'update_alert_message_payload' in local_var_params:
            body_params = local_var_params['update_alert_message_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/message', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_alert_priority(self, identifier, update_alert_priority_payload, **kwargs):  # noqa: E501
        """Update Alert Priority  # noqa: E501

        Update the priority of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_alert_priority(identifier, update_alert_priority_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param UpdateAlertPriorityPayload update_alert_priority_payload: Request payload of update alert priority (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_alert_priority_with_http_info(identifier, update_alert_priority_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.update_alert_priority_with_http_info(identifier, update_alert_priority_payload, **kwargs)  # noqa: E501
            return data

    def update_alert_priority_with_http_info(self, identifier, update_alert_priority_payload, **kwargs):  # noqa: E501
        """Update Alert Priority  # noqa: E501

        Update the priority of the alert with given identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_alert_priority_with_http_info(identifier, update_alert_priority_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of alert which could be alert id, tiny id or alert alias (required)
        :param UpdateAlertPriorityPayload update_alert_priority_payload: Request payload of update alert priority (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'update_alert_priority_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_alert_priority" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `update_alert_priority`")  # noqa: E501
        # verify the required parameter 'update_alert_priority_payload' is set
        if ('update_alert_priority_payload' not in local_var_params or
                local_var_params['update_alert_priority_payload'] is None):
            raise ApiValueError("Missing the required parameter `update_alert_priority_payload` when calling `update_alert_priority`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'update_alert_priority_payload' in local_var_params:
            body_params = local_var_params['update_alert_priority_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/{identifier}/priority', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_saved_search(self, identifier, update_saved_search_payload, **kwargs):  # noqa: E501
        """Update Saved Search  # noqa: E501

        Update saved search for the given search identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_saved_search(identifier, update_saved_search_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of the saved search which could be 'id' or 'name' (required)
        :param UpdateSavedSearchPayload update_saved_search_payload: Request payload of updating saved search (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', or 'name'
        :return: GetSavedSearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_saved_search_with_http_info(identifier, update_saved_search_payload, **kwargs)  # noqa: E501
        else:
            (data) = self.update_saved_search_with_http_info(identifier, update_saved_search_payload, **kwargs)  # noqa: E501
            return data

    def update_saved_search_with_http_info(self, identifier, update_saved_search_payload, **kwargs):  # noqa: E501
        """Update Saved Search  # noqa: E501

        Update saved search for the given search identifier  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_saved_search_with_http_info(identifier, update_saved_search_payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str identifier: Identifier of the saved search which could be 'id' or 'name' (required)
        :param UpdateSavedSearchPayload update_saved_search_payload: Request payload of updating saved search (required)
        :param str identifier_type: Type of the identifier that is provided as an in-line parameter. Possible values are 'id', or 'name'
        :return: GetSavedSearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['identifier', 'update_saved_search_payload', 'identifier_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_saved_search" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'identifier' is set
        if ('identifier' not in local_var_params or
                local_var_params['identifier'] is None):
            raise ApiValueError("Missing the required parameter `identifier` when calling `update_saved_search`")  # noqa: E501
        # verify the required parameter 'update_saved_search_payload' is set
        if ('update_saved_search_payload' not in local_var_params or
                local_var_params['update_saved_search_payload'] is None):
            raise ApiValueError("Missing the required parameter `update_saved_search_payload` when calling `update_saved_search`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'identifier' in local_var_params:
            path_params['identifier'] = local_var_params['identifier']  # noqa: E501

        query_params = []
        if 'identifier_type' in local_var_params:
            query_params.append(('identifierType', local_var_params['identifier_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'update_saved_search_payload' in local_var_params:
            body_params = local_var_params['update_saved_search_payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['GenieKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/alerts/saved-searches/{identifier}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetSavedSearchResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
